﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
Sub Process_Globals
	Dim terms As List
	Dim typesMap As Map
	Dim termsMap As Map
End Sub

'Note that this subroutine is only called when the QSScript contains the specifier "<SEARCH B4XTypes"
Sub B4XTypes(termString As String) As List		'ignore
	If terms.IsInitialized = False Then
		terms.initialize
		typesMap.Initialize
		termsMap.initialize
		Dim scriptDir As String = "QSScripts/coderAssistant"
		terms = File.ReadList (scriptDir, "terms.txt")
		Dim prevTwo As String = ""
		For Each s As String In terms
			If s.Trim<>"" And s.StartsWith("-") = False Then
				Dim firstTwo As String = s.SubString2(0, 2).toLowerCase
				Dim v() As String = scriptUtils.twoParts(s, " ")
				s =  v(1).trim
				v = scriptUtils.twoParts(s, "=")
				Dim w() As String = Regex.Split("\~", v(1).trim)
				Dim refs As List: refs.Initialize
				refs.Add(v(0))
				For Each g As String In w
					refs.Add(g)
				Next
				If firstTwo = prevTwo Then
					Dim set As List = termsMap.get(firstTwo)
					set.Add(refs)
				Else
					Dim newset As List: newset.Initialize
					newset.Add(refs)
					termsMap.put(firstTwo, newset)
					prevTwo = firstTwo
				End If
			End If
		Next
	End If

	Return termsMap.Get(termString)
End Sub
