﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=6.01
@EndOfDesignText@
Sub Process_Globals
End Sub

Sub Search(myPnl As myPanel, row As Int, content As String, specification As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append($"${content}<div>"$)
	Dim st As String  = $"font-size: ${hPX(myPnl,  9)}; position: relative;
	left: 0px; top: -${xPX(myPnl.height/75)}; width: ${xPX(myPnl.width/10)}; height: ${xPX(myPnl.height/28)};"$
	sb.append($"<input type="text" id="twolet" autofocus style="${st}"/>"$)
	
	sb.Append($"</select>"$)
	st = $"font-size: ${hPX(myPnl,  9)}; background-color: DarkGreen; color: White;"$
	sb.Append($"&nbsp &nbsp &nbsp<button id="btnsearch-${specification}" style="${st}">GO</button>"$)
	
	Dim alph As String = "abcdefghijklmnopqrstuvwxyz"
	st = $"font-size: ${hPX(myPnl,  9)};"$
	sb.Append($"&nbsp &nbsp &nbsp<select id="lsta" style="${st}">"$)
	For i = 0 To 25
		Dim opt As String = alph.charAt(i)
		sb.Append($"<option value="${opt}">${opt}</option>"$)
	Next
	sb.Append($"</select>"$)
	sb.Append($"&nbsp &nbsp &nbsp<select id="lstb" style="${st}">"$)
	For i = 0 To 25
		Dim opt As String = alph.charAt(i)
		sb.Append($"<option value="${opt}">${opt}</option>"$)
	Next

	sb.Append("</div>")
	' B4XTypes
	Return sb.toString
End Sub


Sub Admin(myPnl As myPanel, row As Int, specification As String, qResult As List) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append("Select users")
	
	Dim st As String = $"vertical-align:top; font-size: ${hPX(myPnl,  9)}; width: ${xPX(myPnl.width/2.5)};"$
	sb.Append($"&nbsp &nbsp &nbsp<select id="adminlstx" size="20" style="${st}">"$)
	
	Dim opt As String = "All sessions all users"
	sb.Append($"<option value="${opt}">${opt}</option>"$)

	opt  = "Activity in past 30 days"
	sb.Append($"<option value="${opt}">${opt}</option>"$)

	opt  = "Activity in past 7 days"
	sb.Append($"<option value="${opt}">${opt}</option>"$)

	opt  = "---"
	sb.Append($"<option value="${opt}">${opt}</option>"$)
	
	Dim lastUser As String = "!"
	Dim numUsers As Int = 0
	Dim nsessions As Int = 0
	For Each t() As String In qResult
		If t(2)="client" Then
			numUsers = numUsers + 1
			If t(1)<>lastUser Then
				If lastUser<>"!" Then
					opt = lastUser & " (n=" & nsessions & ")"
					If lastUser = "" Then opt = "Anon" & opt
					sb.Append($"<option value="${lastUser}" >${opt}</option>"$)
				End If
				lastUser = t(1)
				nsessions = 1
			Else
				nsessions = nsessions + 1
			End If
		End If
	Next
	If numUsers>0 Then
		opt = lastUser & " (n=" & nsessions & ")"
		sb.Append($"<option value="${lastUser}" >${opt}</option>"$)
	End If
	sb.Append($"</select>"$)
	st = $"font-size: ${hPX(myPnl,  9)}; background-color: DarkGreen; color: White;"$
	sb.Append($"&nbsp &nbsp &nbsp<button id="admingo" style="${st}">GO</button>"$)

	Return sb.toString
End Sub

Sub CheckBox(myPnl As myPanel, row As Int, content As String, oldData As String) As String
	Dim checked As String = ""
	If oldData = "*" Then checked = $" checked="checked""$
	Dim sb As StringBuilder: sb.initialize
	Dim st As String = $"width: ${wPX(myPnl,  12)}; height: ${wPX(myPnl,  10)};"$
	sb.append($"<input type="checkbox" id="chkn${row}" value="*"  ${checked} style="${st}"/>"$)
	st = $"margin-left: ${wPX(myPnl,  20)};"$
	sb.Append($"<label for="chkn${row}" style="${st}">${content}</label>"$)
	Return sb.toString
End Sub

Sub CheckBox2(myPnl As myPanel, row As Int, content As String, oldData As String) As String
	Dim checked As String = ""
	If oldData = "*" Then checked = $" checked="checked""$
	Dim sb As StringBuilder: sb.initialize
	Dim st As String = $"float: right;"$
	Dim st2 As String  = $"position: relative; top: -${wPX(myPnl,  4)}; float: right; width: ${wPX(myPnl,  12)}; height: ${wPX(myPnl,  10)};"$
	sb.Append($"<label for="chkn${row}" style="${st}">${content}&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</label>"$)
	sb.Append($"<input Type="checkbox" id="chkn${row}" value="*"  ${checked} style="${st2}"/>"$)
	Return sb.toString
End Sub

Sub RadioButtonsV(myPnl As myPanel, row As Int, content As String, pars As String, oldData As String) As String
	Dim options() As String = Regex.Split("\|", pars)
	If options.Length<4 And pars.Length<35 Then
		Return RadioButtonsH(myPnl, row, content, pars, oldData, "OPTIONS")
	Else
		Dim old As Int = -1
		If oldData.Length>0 Then old = oldData
		Dim sb As StringBuilder: sb.initialize
		sb.Append(content)
		sb.Append($"<div>"$)
		For m = 0 To options.Length-1
			Dim checked As String = ""
			If m = old Then checked = $" checked="checked""$
			Dim lab As String = options(m)
			If lab.IndexOf("==")>-1 Then lab = lab.SubString2(0,lab.IndexOf("=="))
			sb.Append($"<p style="padding: ${hPX(myPnl,  4)};">"$)
			Dim st As String = $"width: ${wPX(myPnl,  10)}; height: ${hPX(myPnl,  8)};"$
			sb.Append($"<input type="radio" id="rbtn${row}_${m}" name="q${row}" value="${m}" ${checked} style="${st}"/>"$)
			st = $"margin-left: ${wPX(myPnl,  10)};"$
			sb.Append($"<label for="rbtn${row}_${m}" style="${st}">${lab}</label></p>"$)
		Next
		sb.Append("</div>")
		Return sb.toString
	End If
End Sub


Sub RadioButtonsH(myPnl As myPanel, row As Int, content As String, pars As String, oldData As String, sp As String) As String
	Dim old As Int = -1
	If oldData.Length>0 Then old = oldData
	Dim options() As String = Regex.Split("\|", pars)
	Dim nItems As Int = options.Length
	
	Dim w1 As Int = .25*myPnl.width
	Dim w2 As Int = (myPnl.width-2*w1)/(nItems)
	
	Dim labs As List: labs.initialize
	Dim leftLab As String = ""
	Dim rightLab As String = ""
	For i = 0 To nItems-1
		Dim labX As String = options(i)
		If labX.IndexOf("==")>-1 Then labX = labX.SubString2(0,labX.IndexOf("=="))
		Dim labPartsX() As String = scriptUtils.twoParts(labX, "=")
		labs.Add(labPartsX(0))
		If sp = "SCALE" Then
			If i = 0 Then leftLab = labPartsX(1) & " &#8658"
			If i = options.length-1 Then rightLab = "&#8656 " & labPartsX(1)
		End If
	Next
	labs.InsertAt(0, leftLab)
	labs.add(rightLab)
	
	Dim centered As String = "<CENTER>"
	If sp="SCALE" Then centered = ""
	Dim sb As StringBuilder: sb.initialize
	sb.Append($"<div>${centered}${content}</div>"$)
	sb.Append($"<div style="padding-top: 0px;"><table border="0px solid Black" width="100%">"$)
	sb.append("<tr>")
	For i = 0 To nItems+1
		Dim w As Int = w2
		Dim a As String = "center"
		If i = 0 Then w = w1
		If i = nItems+1 Then w = w1
		Dim st As String = $"text-align: ${a}; font-size: ${hPX(myPnl,  7)}; font-weight: bold; color: Black"$
		If i>0 And i<nItems+1 Then
			Dim j As Int = i - 1
			Dim checked As String = ""
			If j = old Then checked = $" checked="checked""$
			Dim st2 As String = $"height: ${hPX(myPnl,  8)}; width: ${xPX(w)};"$
			sb.append($"<td width="${xPX(w)}" style="${st}"><center><input type="radio" id="rbtn${row}_${j}" name="q${row}" value="${j}" ${checked}
			style="${st2}"/></center></td>"$)
		Else
			sb.append($"<td width="${xPX(w)}" style="${st}"></td>"$)
		End If
	Next
	sb.append("</tr><tr>")
	For i = 0 To nItems+1
		Dim j As Int = i - 1
		Dim w As Int = w2
		Dim a As String = "center"
		If i = 0 Then
			w = w1
			a = "right"
		End If
		If i = nItems+1 Then
			w = w1
			a = "left"
		End If
		Dim st As String = $"text-align: ${a}; font-size: ${hPX(myPnl,  7)}; font-weight: bold; color: Black; line-height: 100%"$
		If i>0 And i<nItems+1 Then
			sb.append($"<td width="${xPX(w)}" style="${st}"><center><label for="rbtn${row}_${j}">${labs.Get(i)}</center></label></td>"$)
		Else
			sb.append($"<td width="${xPX(w)}" style="${st}">${labs.Get(i)}</td>"$)
		End If
	Next
	sb.append($"</tr></table></div>"$)
	Return sb.toString
End Sub

Sub SelectList(myPnl As myPanel, row As Int, content As String, specification As String, oldData As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append(content)
	Dim p() As String = Regex.Split(" ", specification)
	Dim startNumber As Int = DateTime.GetYear(DateTime.Now)
	Dim rangeFrom As String = ""
	Dim rangeTo As String = "" & (startNumber-200)
	For i = 0 To p.Length-1
		If (p(i)="" Or p(i)="LIST" Or p(i)="TO") = False Then
			If rangeFrom = "" Then rangeFrom = p(i) Else rangeTo = p(i)
		End If
	Next
	If rangeFrom.toLowerCase = "thisyear" Then rangeFrom = "" & startNumber
	Dim n1 As Int = rangeFrom
	Dim n2 As Int = rangeTo
	Dim st As String = $"font-size: ${hPX(myPnl,  9)};"$
	sb.Append($"&nbsp &nbsp &nbsp<select id="lstn${row}" value="${oldData}" style="${st}">"$)
	sb.Append($"<option value="blank">&nbsp</option>"$)
	For opt = n1 To n2 Step -1
		Dim sel As String = ""
		If oldData = "" & opt Then sel = $" selected="selected""$
		sb.Append($"<option value="${opt}" ${sel}>${opt}</option>"$)
	Next
	sb.Append($"</select>"$)
	Return sb.toString
End Sub

Sub Input(myPnl As myPanel, row As Int, content As String, thisType As String, oldData As String, firstTextInput As Boolean) As String
	Dim getsFocus As String = ""
	If firstTextInput = False Then
		getsFocus  = "autofocus"
		firstTextInput = True
	End If
	Dim sb As StringBuilder: sb.initialize
	sb.Append("<div>")
	Dim st As String = $"left: -${xPX(myPnl.width/2)}; width: ${xPX(myPnl.width/2.1)};"$
	sb.Append($"<label class="inputLabel" for="txtn${row}" style="${st}">${content}</label>"$)
	st = $"font-size: ${hPX(myPnl,  9)}; position: relative; left: ${xPX(myPnl.width/3.05)}; width: ${xPX(myPnl.width/3)}; height: ${xPX(myPnl.height/28)};"$
	sb.append($"<input type="${thisType}" id="txtn${row}" value="${oldData}" ${getsFocus} style="${st}"/>"$)
	sb.Append("</div>")
	Return sb.toString
End Sub

Sub Info(myPnl As myPanel, content As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append(content)
	Return sb.toString
End Sub

Sub Link(myPnl As myPanel, content As String, target As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append($"<a href="${target}">${content}</a>"$)
	Return sb.toString
End Sub

Sub Subtitle(myPnl As myPanel, content As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append($"<center>${content}</center>"$)
	Return sb.toString
End Sub

Sub Bullet(myPnl As myPanel, content As String) As String
	Dim sb As StringBuilder: sb.initialize
	sb.Append(content)
	Return sb.toString
End Sub


Sub hPX(myPnl As myPanel, pt As Float) As String
	Return Round(pt*myPnl.Height/385) & "px"
End Sub

Sub wPX(myPnl As myPanel, pt As Float) As String
	Return Round(pt*myPnl.Width/385) & "px"
End Sub

Sub xPX(pt As Float) As String
	Return Round(pt) & "px"
End Sub
